var data  = {
        name : "",
        children : []
};




//定义画布宽高和生成点的个数
var WIDTH = window.innerWidth, HEIGHT = window.innerHeight, POINT = 0; //节点个数

var canvas = document.getElementById('canvas');
canvas.width = WIDTH,
canvas.height = HEIGHT;
var context = canvas.getContext('2d');
// context.strokeStyle = 'rgba(70,65,67,0.1)', //边框颜色
context.strokeWidth = 0,
context.fillStyle = 'rgba(70,65,67,0.1)';
var lineOpacity = 0.02;   //连线透明度

//在中间写字
context.font = "normal 8pt Arial";  //字体大小，样式
context.textAlign = 'center';  // 位置
context.textBaseline = 'middle';


var circleArr = [];

//线条：开始xy坐标，结束xy坐标，线条透明度
function Line (x, y, _x, _y, o) {
    this.beginX = x,
    this.beginY = y,
    this.closeX = _x,
    this.closeY = _y,
    this.o = o;
}
//点：圆心xy坐标，半径，每帧移动xy的距离
function Circle (x, y, r, moveX, moveY) {
    this.x = x,
    this.y = y,
    this.r = r,
    this.moveX = moveX,
    this.moveY = moveY;
}
//生成max和min之间的随机数
function num (max, _min) {
    var min = arguments[1] || 0;
    return Math.floor(Math.random()*(max-min+1)+min);
}
// 绘制原点
function drawCricle (cxt, x, y, r, moveX, moveY) {
    var circle = new Circle(x, y, r, moveX, moveY)
    cxt.beginPath()
    cxt.arc(circle.x, circle.y, circle.r, 0, 2*Math.PI)
    cxt.closePath()
    cxt.fill();
    return circle;
}
//绘制线条
function drawLine (cxt, x, y, _x, _y, o) {
    var line = new Line(x, y, _x, _y, o)
    cxt.beginPath()
	cxt.lineWidth = 5;  //线宽
    cxt.strokeStyle = 'rgba(90,0,0,'+ o +')'  //可改连线颜色，透明度不在这改
    cxt.moveTo(line.beginX, line.beginY)
    cxt.lineTo(line.closeX, line.closeY)
    cxt.closePath()
    cxt.stroke();

}


function json2(jsontree) {
    if ((typeof jsontree == 'object') && (jsontree.constructor== Object.prototype.constructor)) {
        var arrey = [];
        arrey.push(jsontree);
    }
    else arrey = jsontree;
    for (var i = 0; i < arrey.length; i++) {
        var jn = arrey[i];
        circleArr.push(drawCricle(context, num(WIDTH), num(HEIGHT), num( 45, 35), num(10, -10)/10, num(10, -10)/10));

        if (jn.children && jn.children.length > 0) {
            json2(jn.children);
        }
    }
}



//初始化生成原点
function init () {
    circleArr = [];

    json2(data);

    draw();
}


var temp = 0;
var m = -1;
function json(jsontree) {
	if(m>POINT-2) {   //bug解决方法
		temp = 0;m=-1
	}
    if ((typeof jsontree == 'object') && (jsontree.constructor== Object.prototype.constructor)) {
        var arrey = [];
        arrey.push(jsontree);
    }
    else {arrey = jsontree;}

    temp = m;

    for (var i = 0; i < arrey.length; i++) {
        var jn = arrey[i];
		m=m+1;

        context.fillStyle = 'rgba(0,20,20,0.6)';  //圆颜色
        drawCricle(context, circleArr[m].x, circleArr[m].y, circleArr[m].r);
        context.fillStyle = 'rgba(255,255,255,1)';		//字颜色
        context.fillText(jn.name, circleArr[m].x, circleArr[m].y);  //添加文字
		if(temp>=0){
			drawLine(context, circleArr[m].x, circleArr[m].y, circleArr[temp].x, circleArr[temp].y, lineOpacity);
		}

        if (jn.children && jn.children.length > 0) {

            json(jn.children);
        }
    }
}


//每帧绘制
function draw () {
    context.clearRect(0,0,canvas.width, canvas.height);


    json(data);

}

//调用执行
window.onload = function () {

    getEntryData();

    if(POINT > 0) {
        init();

        setInterval(function () {
            for (var i = 0; i < POINT; i++) {
                var cir = circleArr[i];
                cir.x += cir.moveX;
                cir.y += cir.moveY;
                if (cir.x > WIDTH) cir.x = 0;
                else if (cir.x < 0) cir.x = WIDTH;
                if (cir.y > HEIGHT) cir.y = 0;
                else if (cir.y < 0) cir.y = HEIGHT;
            }

            draw();

        }, 16);
    }
}

function getEntryData(){
    $.ajax({
        url: host + "/gif",
        type: "get",
        dataType: "json",
        async: false,
        data: {
        },
        success: function(ret){
//                    alert(JSON.stringify(ret));
            if(ret.list.children.length > 0) {
                data = ret.list;
                POINT = ret.num;
            }
        },
        error: function(err){
            alert("发生未知错误");
//                    alert(JSON.stringify(err));
        }
    });
}
